diff --git a/src/fsm.c b/src/fsm.c
index 603e8b440..c1f132a0c 100644
--- a/src/fsm.c
+++ b/src/fsm.c
@@ -2907,132 +2854,621 @@ ni_ifworker_type_from_object_path(const char *path, const char **suffix)
 /*
  * Get all interfaces matching some user-specified criteria
  */
-unsigned int
-ni_fsm_get_matching_workers(ni_fsm_t *fsm, ni_ifmatcher_t *match, ni_ifworker_array_t *result)
+static ni_bool_t
+ni_fsm_ifmatch_worker_name(const ni_ifmatcher_t *match, const ni_ifworker_t *w,
+		ni_log_fn_t *logit)
 {
-	void (*logit)(const char *, ...) __fmtattr;
-	unsigned int i;
-
-	if (ni_string_eq(match->name, "all")) {
-		match->name = NULL;
-		logit = ni_info;
-	} else {
-		logit = ni_note;
+	/*
+	 * Note: match->name==NULL is matching all worker ("ifup all")
+	 */
+	if (match->name && !ni_string_eq(w->name, match->name)) {
+		ni_debug_verbose(NI_LOG_DEBUG2, NI_TRACE_APPLICATION,
+			"skipping '%s' %s: not requested (here)",
+			w->name, ni_ifworker_type_to_string(w->type));
+		return FALSE;
+	} else if (match->name) {
+		ni_debug_verbose(NI_LOG_DEBUG2, NI_TRACE_APPLICATION,
+			"checking '%s' %s: requested by name",
+			w->name, ni_ifworker_type_to_string(w->type));
 	}
+	return TRUE;
+}
 
-	for (i = 0; i < fsm->workers.count; ++i) {
-		ni_ifworker_t *w = fsm->workers.data[i];
+static ni_bool_t
+ni_fsm_ifmatch_worker_type(const ni_ifmatcher_t *match, const ni_ifworker_t *w,
+		ni_log_fn_t *logit, ni_ifworker_type_t type)
+{
+	if (w->type != type) {
+		logit("skipping '%s' %s: type is '%s'",
+			w->name, ni_ifworker_type_to_string(type),
+			ni_ifworker_type_to_string(w->type));
+		return FALSE;
+	}
+	return TRUE;
+}
 
-		if (w->type != NI_IFWORKER_TYPE_NETDEV)
-			continue;
+static ni_bool_t
+ni_fsm_ifmatch_netif_worker(const ni_ifmatcher_t *match, const ni_ifworker_t *w,
+		ni_log_fn_t *logit)
+{
+	/*
+	 * well, we (still) don't handle modem workers yet and
+	 * most probably never via ifup|ifdown|ifreload <modem>
+	 * but either as reference/dependency or another action
+	 * and probably also different matches.
+	 */
+	return ni_fsm_ifmatch_worker_type(match, w, logit, NI_IFWORKER_TYPE_NETDEV);
+}
 
-		if (w->dead)
-			continue;
+static ni_bool_t
+ni_fsm_ifmatch_dead_worker(const ni_ifmatcher_t *match, const ni_ifworker_t *w,
+		ni_log_fn_t *logit)
+{
+	if (w->dead) {
+		/* seems to be not used any more ... */
+		logit("skipping '%s' %s: marked \"dead\"",
+			w->name, ni_ifworker_type_to_string(w->type));
+		return FALSE;
+	}
+	return TRUE;
+}
 
-		if (!match->mode && !match->ignore_startmode) {
-			if (ni_string_eq_nocase(w->control.mode, "off"))
-				continue;
+static ni_bool_t
+ni_fsm_ifmatch_startmode(const ni_ifmatcher_t *match, const ni_ifworker_t *w,
+		ni_log_fn_t *logit)
+{
+	if (match->ifdown)
+		return TRUE;
 
-			if (!match->name && ni_string_eq_nocase(w->control.mode, "manual"))
-				continue;
-		}
+	if (match->mode && !ni_string_eq(w->control.mode, match->mode)) {
+		logit("skipping '%s' %s: control/start mode is \"%s\"",
+			w->name, ni_ifworker_type_to_string(w->type),
+			w->control.mode);
+		return FALSE;
+	}
 
-		if (match->name && !ni_string_eq(match->name, w->name))
-			continue;
+	/* ignore_startmode is a disabled testing hack */
+	if (match->ignore_startmode)
+		return TRUE;
 
-		/* skipping ifworkers without xml configuration */
-		if (match->require_config && !w->config.node) {
-			logit("skipping %s interface: "
-				"no configuration provided", w->name);
-			continue;
+	if (ni_string_eq_nocase(w->control.mode, "off")) {
+		logit("skipping '%s' %s: disabled in the configuration",
+			w->name, ni_ifworker_type_to_string(w->type));
+		return FALSE;
+	}
+	if (!match->name && ni_string_eq_nocase(w->control.mode, "manual")) {
+		logit("skipping '%s' %s: control/start mode is \"%s\"",
+			w->name, ni_ifworker_type_to_string(w->type),
+			w->control.mode);
+		return FALSE;
+	}
+
+	return TRUE;
+}
+
+static ni_bool_t
+ni_fsm_ifmatch_config_to_apply(const ni_ifmatcher_t *match, const ni_ifworker_t *w,
+		ni_log_fn_t *logit)
+{
+	/* skipping ifworkers without (xml) configuration to apply */
+	if (match->require_config && !w->config.node) {
+		logit("skipping '%s' %s: no configuration to apply found",
+			w->name, ni_ifworker_type_to_string(w->type));
+		return FALSE;
+	}
+	return TRUE;
+}
+
+static ni_bool_t
+ni_fsm_ifmatch_config_applied(const ni_ifmatcher_t *match, const ni_ifworker_t *w,
+		ni_log_fn_t *logit)
+{
+	ni_client_state_t *cs = w->device ? w->device->client_state : NULL;
+
+	/* skipping ifworkers of interfaces not configured in the past */
+	if (match->require_configured && (!cs || ni_string_empty(cs->config.origin))) {
+		logit("skipping '%s' %s: not configured by wicked yet",
+			w->name, ni_ifworker_type_to_string(w->type));
+		return FALSE;
+	}
+
+	return TRUE;
+}
+
+static ni_bool_t
+ni_fsm_ifmatch_persistent(const ni_ifmatcher_t *match, const ni_ifworker_t *w,
+		ni_log_fn_t *logit)
+{
+	const ni_client_state_t *cs = w->device ? w->device->client_state : NULL;
+
+	/* skipping ifworkers of interfaces in persistent mode */
+	if (!match->allow_persistent && cs && cs->control.persistent) {
+		logit("skipping '%s' %s: persistent mode is on",
+			w->name, ni_ifworker_type_to_string(w->type));
+		return FALSE;
+	}
+	return TRUE;
+}
+
+static ni_bool_t
+ni_fsm_ifmatch_user_controlled(const ni_ifmatcher_t *match, const ni_ifworker_t *w,
+		ni_log_fn_t *logit)
+{
+	/* skipping ifworkers of interfaces user must not control */
+	if (!w->control.usercontrol && geteuid() != 0) {
+		logit("skipping '%s' %s: user control is not allowed",
+			w->name, ni_ifworker_type_to_string(w->type));
+		return FALSE;
+	}
+	return TRUE;
+}
+
+static ni_bool_t
+ni_fsm_ifmatch_boot_stage(const ni_ifmatcher_t *match, const ni_ifworker_t *w,
+		ni_log_fn_t *logit)
+{
+	if (match->boot_stage && !ni_string_eq(w->control.boot_stage, match->boot_stage)) {
+		logit("skipping '%s' %s: enabled in boot stage '%s'",
+			w->name, ni_ifworker_type_to_string(w->type),
+			w->control.boot_stage);
+		return FALSE;
+	}
+	return TRUE;
+}
+
+static ni_bool_t
+ni_fsm_ifmatch_skip_origin(const ni_ifmatcher_t *match, const ni_ifworker_t *w,
+		ni_log_fn_t *logit)
+{
+	if (match->skip_origin) {
+		ni_netdev_t *dev = w->device;
+		ni_client_state_t *cs = dev ? dev->client_state : NULL;
+		const char *origin = cs ? cs->config.origin : NULL;
+
+		if (ni_string_startswith(origin, match->skip_origin)) {
+			logit("skipping '%s' %s: config origin is '%s'",
+				w->name, ni_ifworker_type_to_string(w->type),
+				origin);
+			return FALSE;
 		}
-		/* skipping ifworkers of interfaces not configured in the past */
-		if (match->require_configured &&
-		    ni_string_empty(w->config.meta.origin)) {
-			logit("skipping %s interface: "
-				"device is not configured by wicked yet", w->name);
+	}
+	return TRUE;
+}
+
+static ni_bool_t
+ni_fsm_ifmatch_activated(const ni_ifmatcher_t *match, const ni_ifworker_t *w,
+		ni_log_fn_t *logit)
+{
+	/*
+	 * Skip active means omit running and succeeded worker
+	 * Hmm... obsolete direct setup without nanny only
+	 */
+	if (match->skip_active && w->kickstarted &&
+	    (ni_ifworker_is_running(w) || ni_ifworker_has_succeeded(w))) {
+		logit("skipping '%s' %s: already active",
+			w->name, ni_ifworker_type_to_string(w->type));
+		return FALSE;
+	}
+	return TRUE;
+}
+
+static ni_bool_t
+ni_fsm_ifmatch_conditions(const ni_ifmatcher_t *match, const ni_ifworker_t *w,
+		ni_log_fn_t *logit)
+{
+	if (!ni_fsm_ifmatch_dead_worker(match, w, logit))
+		return FALSE;
+	if (!ni_fsm_ifmatch_startmode(match, w, logit))
+		return FALSE;
+	if (!ni_fsm_ifmatch_persistent(match, w, logit))
+		return FALSE;
+	if (!ni_fsm_ifmatch_config_to_apply(match, w, logit))
+		return FALSE;
+	if (!ni_fsm_ifmatch_config_applied(match, w, logit))
+		return FALSE;
+	if (!ni_fsm_ifmatch_user_controlled(match, w, logit))
+		return FALSE;
+	if (!ni_fsm_ifmatch_boot_stage(match, w, logit))
+		return FALSE;
+	if (!ni_fsm_ifmatch_skip_origin(match, w, logit))
+		return FALSE;
+	if (!ni_fsm_ifmatch_activated(match, w, logit))
+		return FALSE;
+	return TRUE;
+}
+
+static ni_bool_t
+ni_fsm_ifmatch_reload_config(const ni_ifmatcher_t *match, const ni_ifworker_t *w,
+		ni_log_fn_t *logit)
+{
+	const ni_client_state_t *cs = w->device ? w->device->client_state : NULL;
+
+	if (!match->ifreload)
+		return TRUE;
+
+	if (w->config.node && cs && ni_uuid_equal(&cs->config.uuid, &w->config.meta.uuid)) {
+		logit("skipping '%s' %s: configuration not changed",
+			w->name, ni_ifworker_type_to_string(w->type));
+		return FALSE;
+	}
+
+	return TRUE;
+}
+
+static const char *		ni_ifworker_guard_print(ni_stringbuf_t *,
+						const ni_ifworker_array_t *,
+						const char *);
+
+static ni_bool_t		ni_ifworker_references_ok(
+						const ni_ifworker_array_t *,
+						ni_ifworker_t *);
+
+static ni_bool_t		ni_fsm_ifmatch_pull_up(ni_fsm_t *,
+						ni_ifmatcher_t *,
+						ni_ifworker_array_t *,
+						ni_ifworker_array_t *,
+						ni_log_fn_t *,
+						ni_ifworker_t *,
+						ni_bool_t, ni_bool_t,
+						ni_bool_t, ni_bool_t);
+
+static ni_bool_t
+ni_fsm_ifmatch_pull_up_ports(ni_fsm_t *fsm, ni_ifmatcher_t *match,
+		ni_ifworker_array_t *result, ni_ifworker_array_t *guard,
+		ni_log_fn_t *logit, ni_ifworker_t *master,
+		ni_bool_t ports, ni_bool_t links)
+{
+	ni_ifworker_t *port;
+	unsigned int i;
+
+	for (i = 0; i < fsm->workers.count; ++i) {
+		port = fsm->workers.data[i];
+
+		if (port->masterdev != master)
 			continue;
-		}
-		/* skipping ifworkers of interfaces in the persistent mode */
-		if (!match->allow_persistent && w->control.persistent) {
-			logit("skipping %s interface: "
-				"persistent mode is on", w->name);
+
+		/* desired/requested, but not mandatory */
+		ni_fsm_ifmatch_pull_up(fsm, match, result, guard,
+				logit, port, FALSE, TRUE, ports, links);
+	}
+	return TRUE;
+}
+
+static ni_bool_t
+ni_fsm_ifmatch_pull_up_links(ni_fsm_t *fsm, ni_ifmatcher_t *match,
+		ni_ifworker_array_t *result, ni_ifworker_array_t *guard,
+		ni_log_fn_t *logit, ni_ifworker_t *lower,
+		ni_bool_t ports, ni_bool_t links)
+{
+	ni_ifworker_t *link;
+	unsigned int i;
+
+	for (i = 0; i < fsm->workers.count; ++i) {
+		link = fsm->workers.data[i];
+
+		if (link->lowerdev == lower)
 			continue;
-		}
 
-		/* skipping ifworkers of interfaces user must not control */
-		if (!w->control.usercontrol && geteuid() != 0) {
-			logit("skipping %s interface: "
-				"user control is not allowed", w->name);
+		/* desired/requested, but not mandatory */
+		ni_fsm_ifmatch_pull_up(fsm, match, result, guard,
+				logit, link, TRUE, FALSE, ports, links);
+	}
+	return TRUE;
+}
+
+static ni_bool_t
+ni_fsm_ifmatch_pull_up_lower(ni_fsm_t *fsm, ni_ifmatcher_t *match,
+		ni_ifworker_array_t *result, ni_ifworker_array_t *guard,
+		ni_log_fn_t *logit, ni_ifworker_t *w,
+		ni_bool_t master, ni_bool_t lower,
+		ni_bool_t ports, ni_bool_t links)
+{
+	if (!w->lowerdev)
+		return TRUE; /* we don't have a lower */
+
+	if (!ni_fsm_ifmatch_pull_up(fsm, match, result, guard,
+			logit, w->lowerdev, master, lower, ports, FALSE)) {
+
+		logit("skipping '%s' %s: unable to setup lower %s '%s'",
+			w->name, ni_ifworker_type_to_string(w->type),
+			ni_ifworker_type_to_string(w->lowerdev->type),
+			w->lowerdev->name);
+		return FALSE;
+	}
+	return TRUE;
+}
+
+static ni_bool_t
+ni_fsm_ifmatch_pull_up_master(ni_fsm_t *fsm, ni_ifmatcher_t *match,
+		ni_ifworker_array_t *result, ni_ifworker_array_t *guard,
+		ni_log_fn_t *logit, ni_ifworker_t *w,
+		ni_bool_t master, ni_bool_t lower,
+		ni_bool_t ports, ni_bool_t links)
+{
+	if (!w->masterdev)
+		return TRUE; /* we don't have a master */
+
+	if (!ni_fsm_ifmatch_pull_up(fsm, match, result, guard,
+			logit, w->masterdev, master, lower, FALSE, links)) {
+
+		logit("skipping '%s' %s: unable to setup master %s '%s'",
+			w->name, ni_ifworker_type_to_string(w->type),
+			ni_ifworker_type_to_string(w->masterdev->type),
+			w->masterdev->name);
+		return FALSE;
+	}
+
+	return TRUE;
+}
+
+static ni_bool_t
+ni_fsm_ifmatch_pull_up(ni_fsm_t *fsm, ni_ifmatcher_t *match,
+		ni_ifworker_array_t *result, ni_ifworker_array_t *guard,
+		ni_log_fn_t *logit, ni_ifworker_t *w,
+		ni_bool_t master, ni_bool_t lower,
+		ni_bool_t ports, ni_bool_t links)
+{
+	if (ni_ifworker_array_index(result, w) != -1)
+		return TRUE;
+
+	/*
+	 * Check loop guard before pulling references.
+	 */
+	if (!ni_ifworker_references_ok(guard, w))
+		return FALSE;
+
+	ni_ifworker_array_append(guard, w);
+
+	if (lower && !ni_fsm_ifmatch_pull_up_lower(fsm, match, result,
+			guard, logit, w, TRUE, TRUE, ports, FALSE)) {
+		ni_ifworker_array_remove(guard, w);
+		return FALSE;
+	}
+
+	if (master && !ni_fsm_ifmatch_pull_up_master(fsm, match, result,
+			guard, logit, w, TRUE, TRUE, FALSE, links)) {
+		ni_ifworker_array_remove(guard, w);
+		return FALSE;
+	}
+
+	if (ports && !ni_fsm_ifmatch_pull_up_ports(fsm, match,
+			result, guard, logit, w, TRUE, FALSE)) {
+		ni_ifworker_array_remove(guard, w);
+		return FALSE;
+	}
+
+	if (links && !ni_fsm_ifmatch_pull_up_links(fsm, match,
+			result, guard, logit, w, FALSE, TRUE)) {
+		ni_ifworker_array_remove(guard, w);
+		return FALSE;
+	}
+
+	ni_ifworker_array_remove(guard, w);
+
+	if (!ni_fsm_ifmatch_conditions(match, w, logit))
+		return FALSE;
+
+	if (!ni_fsm_ifmatch_reload_config(match, w, logit))
+		return TRUE;
+
+	if (ni_ifworker_array_index(result, w) == -1)
+		ni_ifworker_array_append(result, w);
+
+	return TRUE;
+}
+
+static ni_bool_t		ni_fsm_ifmatch_pull_down(ni_fsm_t *,
+						ni_ifmatcher_t *,
+						ni_ifworker_array_t *,
+						ni_ifworker_array_t *,
+						ni_log_fn_t *,
+						ni_ifworker_t *);
+
+static ni_bool_t
+ni_fsm_ifmatch_pull_down_ports(ni_fsm_t *fsm, ni_ifmatcher_t *match,
+		ni_ifworker_array_t *result, ni_ifworker_array_t *guard,
+		ni_log_fn_t *logit, ni_ifworker_t *master)
+{
+	ni_netdev_t *device, *dev;
+	ni_ifworker_t *port;
+	unsigned int i;
+	ni_bool_t ret = TRUE;
+
+	if (!(device = master->device))
+		return TRUE;
+
+	for (i = 0; i < fsm->workers.count; ++i) {
+		port = fsm->workers.data[i];
+		if (!(dev = port ? port->device : NULL))
 			continue;
-		}
 
-		if (match->mode && !ni_string_eq(match->mode, w->control.mode))
+		if (!ni_string_eq(dev->link.masterdev.name, device->name))
 			continue;
 
-		if (match->boot_stage && !ni_string_eq(match->boot_stage, w->control.boot_stage))
+		/*
+		 * ignore / skip ifdown of ports we didn't configured
+		 * (e.g. VM interfaces in a bridge...) and permit to
+		 * shutdown the requested master (bridge) -- on ifdown
+		 * until master delete, the kernel will unenslave them.
+		 */
+		if (!ni_fsm_ifmatch_config_applied(match, port, logit))
 			continue;
 
-		if (match->skip_origin) {
-			ni_netdev_t *dev = w->device;
-			ni_client_state_t *cs = dev ? dev->client_state : NULL;
-			const char *origin = cs ? cs->config.origin : NULL;
+		if (!ni_fsm_ifmatch_pull_down(fsm, match, result,
+				guard, logit, port))
+			ret = FALSE;
+	}
+	return ret;
+}
 
-			if (ni_string_startswith(origin, match->skip_origin)) {
-				continue;
-			}
-		}
+static ni_bool_t
+ni_fsm_ifmatch_pull_down_links(ni_fsm_t *fsm, ni_ifmatcher_t *match,
+		ni_ifworker_array_t *result, ni_ifworker_array_t *guard,
+		ni_log_fn_t *logit, ni_ifworker_t *lower)
+{
+	ni_netdev_t *device, *dev;
+	ni_ifworker_t *link;
+	unsigned int i;
+	ni_bool_t ret = TRUE;
 
-		/* Skip active means omit running and succeeded worker */
-		if (match->skip_active && w->kickstarted &&
-		    (ni_ifworker_is_running(w) || ni_ifworker_has_succeeded(w))) {
+	if (!(device = lower->device))
+		return TRUE;
+
+	for (i = 0; i < fsm->workers.count; ++i) {
+		link = fsm->workers.data[i];
+		if (!(dev = link ? link->device : NULL))
 			continue;
-		}
 
-		if (match->name) { /* Check only when particular interface specified */
-			if (!match->ifdown) {
-				if (w->masterdev) { /* Pull in also masterdev */
-					if (ni_ifworker_array_index(result, w->masterdev) < 0)
-						ni_ifworker_array_append(result, w->masterdev);
-				}
-				if (w->lowerdev) {
-					if (ni_ifworker_array_index(result, w->lowerdev) < 0)
-						ni_ifworker_array_append(result, w->lowerdev);
-				}
-			}
-			else {
-				if (w->masterdev) {
-					if (ni_ifworker_array_index(result, w->masterdev) < 0) {
-						logit("skipping %s interface: "
-							"unable to ifdown due to master device dependency to: %s",
-							w->name, w->masterdev->name);
-						continue;
-					}
-				}
+		if (!ni_string_eq(dev->link.lowerdev.name, device->name))
+			continue;
 
-				if (w->lowerdev_for.count > 0) {
-					ni_bool_t missing_dep = FALSE;
-					unsigned int i;
+		/*
+		 * ignore / skip ifdown of links we didn't configured,
+		 * (e.g. manually created vlans on top) and permit to
+		 * shutdown the requested master -- on ifdown until
+		 * delete, kernel will cleanup and delete the links.
+		 */
+		if (!ni_fsm_ifmatch_config_applied(match, link, logit))
+			continue;
+
+		if (!ni_fsm_ifmatch_pull_down(fsm, match, result,
+				guard, logit, link))
+			ret = FALSE;
+	}
+	return ret;
+}
 
-					for (i = 0; i < w->lowerdev_for.count; i++) {
-						ni_ifworker_t *dep = w->lowerdev_for.data[i];
+static ni_bool_t
+ni_fsm_ifmatch_pull_down(ni_fsm_t *fsm, ni_ifmatcher_t *match,
+		ni_ifworker_array_t *result, ni_ifworker_array_t *guard,
+		ni_log_fn_t *logit, ni_ifworker_t *w)
+{
+	ni_netdev_t *device;
 
-						if (ni_ifworker_array_index(result, dep) < 0) {
-							logit("skipping %s interface: "
-								"unable to ifdown due to lower device dependency to: %s",
-								w->name, dep->name);
-							missing_dep = TRUE;
-						}
-					}
+	if (!(device = w->device))
+		return TRUE;
 
-					if (missing_dep)
-						continue;
-				}
-			}
-		}
+	if (ni_ifworker_array_index(result, w) != -1)
+		return TRUE;
+
+	/*
+	 * Check loop guard before pulling references.
+	 */
+	if (!ni_ifworker_references_ok(guard, w))
+		return FALSE;
+
+	ni_ifworker_array_append(guard, w);
+
+	/*
+	 * There is no reason to trigger master or lower shutdown
+	 * we (as port or link) refer to -- they don't refer us.
+	 *
+	 * But we have to shutdown all ports and links that refer
+	 * to the worker device via their master/lower device ref.
+	 */
+	if (!ni_fsm_ifmatch_pull_down_ports(fsm, match, result,
+			guard, logit, w)) {
+
+		logit("skipping '%s' %s: unable to shutdown ports",
+			device->name, ni_ifworker_type_to_string(w->type));
+
+		ni_ifworker_array_remove(guard, w);
+		return FALSE;
+	}
+
+	if (!ni_fsm_ifmatch_pull_down_links(fsm, match, result,
+			guard, logit, w)) {
+
+		logit("skipping '%s' %s: unable to shutdown links",
+			device->name, ni_ifworker_type_to_string(w->type));
+
+		ni_ifworker_array_remove(guard, w);
+		return FALSE;
+	}
+
+	ni_ifworker_array_remove(guard, w);
+
+	if (!ni_fsm_ifmatch_conditions(match, w, logit))
+		return FALSE;
+
+	if (!ni_fsm_ifmatch_reload_config(match, w, logit))
+		return TRUE;
+
+	if (ni_ifworker_array_index(result, w) == -1)
+		ni_ifworker_array_append(result, w);
+
+	return TRUE;
+}
+
+unsigned int
+ni_fsm_get_matching_workers(ni_fsm_t *fsm, ni_ifmatcher_t *match,
+		ni_ifworker_array_t *result)
+{
+	ni_ifworker_array_t guard = NI_IFWORKER_ARRAY_INIT;
+	ni_log_fn_t *logit;
+	ni_ifworker_t *w;
+	unsigned int i;
+
+	if (!fsm || !match || !result)
+		return 0;
 
-		if (ni_ifworker_array_index(result,w) < 0)
-			ni_ifworker_array_append(result, w);
+	if (ni_string_eq(match->name, "all")) {
+		match->name = NULL;
+		logit = ni_info;
+	} else {
+		logit = ni_note;
+	}
+
+	for (i = 0; i < fsm->workers.count; ++i) {
+		w = fsm->workers.data[i];
+
+		if (!ni_fsm_ifmatch_netif_worker(match, w, logit) ||
+		    !ni_fsm_ifmatch_worker_name(match, w, logit))
+			continue;
+
+		if (!match->ifdown) {
+			/*
+			 * Get worker incl. config references for setup:
+			 *
+			 * - [1] this->lower reference: pull underlying requirements
+			 *       (we can't exist or start without them at all;
+			 *        e.g. eth0.42 vlan can't exist without eth0)
+			 * - [2] this->master reference: pull master we're port of
+			 *       (we can't finish link setup without them;
+			 *        e.g. port eth0 needs it's bridge br0)
+			 *
+			 * ports trigger [required]:
+			 *   = Desired to pick ports of the requested master,
+			 *     which is the "controlling top level interface".
+			 *   - [3] this<-ports: pull ports referring us as master
+			 *         (e.g. br42 requests it's port eth1.42)
+			 *     - [==1] port->lower: pull port lower requirements
+			 *             (e.g. eth1.42 needs it's underlying eth0)
+			 *
+			 * links trigger [undesired]:
+			 *   = Links depend on lower, but lower does not need any
+			 *     links on top -- lower (L3) setup is independent.
+			 *   - [4] this<-links: pull links referring us as lower
+			 *         (e.g. eth0 requestst to setup eth0.* too)
+			 *         - [==2] link->master: pull link masters
+			 *                 (eth0.* links require their masters)
+			 */
+			ni_fsm_ifmatch_pull_up(fsm, match, result, &guard,
+					logit, w, TRUE, TRUE, TRUE, FALSE);
+			ni_ifworker_array_destroy(&guard);
+		} else {
+			/*
+			 * Get worker incl. system references for shutdown:
+			 *
+			 * - [1] this<-links: pull links referencing us as lower
+			 *       (e.g. shutdown bond0.42 vlan on bond0 goes down)
+			 * - [2] this<-ports: pull ports referencing us as master
+			 *       (e.g. shutdown eth1,eth1 on bond0 goes down)
+			 */
+			ni_fsm_ifmatch_pull_down(fsm, match, result, &guard,
+					logit, w);
+			ni_ifworker_array_destroy(&guard);
+		}
 	}
 
 	return result->count;
@@ -3157,9 +3593,6 @@ __ni_fsm_pull_in_children(ni_ifworker_t *w, ni_ifworker_array_t *array)
 			continue;
 		}
 
-		if (xml_node_is_empty(child->config.node))
-			ni_ifworker_generate_default_config(w, child);
-
 		if (xml_node_is_empty(child->config.node)) {
 			ni_debug_application("%s: ignoring dependent child %s - no config",
 				w->name, child->name);
@@ -3232,10 +3665,6 @@ ni_fsm_mark_matching_workers(ni_fsm_t *fsm, ni_ifworker_array_t *marked, const n
 
 		w->target_range = marker->target_range;
 
-		/* Clean client-info origin and UUID on ifdown */
-		if (marker->target_range.max < NI_FSM_STATE_DEVICE_SETUP)
-			ni_client_state_config_reset(&w->config.meta);
-
 		if (marker->persistent)
 			ni_ifworker_control_set_persistent(w, TRUE);
 	}
@@ -3419,7 +3848,7 @@ ni_ifworker_get_check_state_req_for_methods(ni_ifworker_t *w)
 	 */
 	for (i = 0; i < at[i].next_state; ++i) {
 		ni_fsm_require_list_destroy(&at[i].require.list);
-		__ni_ifworker_get_check_state_reqs_for_method(w, &at[i]);
+		ni_ifworker_get_check_state_reqs_for_method(w, &at[i]);
 	}
 }
 
@@ -3491,8 +3920,9 @@ ni_ifworker_start(ni_fsm_t *fsm, ni_ifworker_t *w, unsigned long timeout)
 static int
 ni_ifworker_bind_device_factory_api(ni_ifworker_t *w)
 {
+	const unsigned int services_max = ni_objectmodel_service_registry_count();
+	const ni_dbus_service_t *list_services[services_max];
 	const ni_dbus_method_t *method;
-	const ni_dbus_service_t *list_services[128];
 	const char *link_type;
 	unsigned int i, count;
 	int rv;
@@ -3536,7 +3966,7 @@ ni_ifworker_bind_device_factory_api(ni_ifworker_t *w)
 		/* We try to locate the factory service by looping over all services compatible
 		 * with netif-list */
 		netif_list_class = ni_objectmodel_get_class(NI_OBJECTMODEL_NETIF_LIST_CLASS);
-		count = ni_objectmodel_compatible_services_for_class(netif_list_class, list_services, 128);
+		count = ni_objectmodel_compatible_services_for_class(netif_list_class, list_services, services_max);
 	}
 
 	for (i = 0; i < count; ++i) {
@@ -3619,8 +4049,100 @@ static dbus_bool_t	ni_ifworker_netif_resolve_cb(xml_node_t *, const ni_xs_type_t
 static int		ni_ifworker_prompt_cb(xml_node_t *, const ni_xs_type_t *, const xml_node_t *, void *);
 static int		ni_ifworker_prompt_later_cb(xml_node_t *, const ni_xs_type_t *, const xml_node_t *, void *);
 
+static inline int
+ni_ifworker_bind_config_service_method_early(ni_ifworker_t *w, ni_fsm_t *fsm,
+		ni_dbus_xml_validate_context_t *context,
+		const ni_dbus_service_t *service,
+		const ni_dbus_method_t *method,
+		xml_node_t *config)
+{
+	xml_node_t *args = NULL;
+	int rv;
+
+	rv = ni_dbus_xml_map_method_argument(method,
+			0, config, &args, NULL);
+	if (rv != NI_SUCCESS) {
+		ni_ifworker_fail(w, "document error: can't map %s.%s() arguments",
+				service->name, method->name);
+		return -NI_ERROR_DOCUMENT_ERROR;
+	}
+
+	if (args) {
+		ni_debug_wicked_xml(args, NI_LOG_DEBUG3,
+			"%s(%s) mapped %s.%s() arguments",
+			__func__, w->name, service->name, method->name);
+
+		if (!ni_dbus_xml_validate_argument(method, 0, args, context)) {
+			ni_ifworker_fail(w, "failed to validate %s.%s() arguments",
+					service->name, method->name);
+				return -NI_ERROR_DOCUMENT_ERROR;
+		}
+	}
+	return NI_SUCCESS;
+}
+
+static inline int
+ni_ifworker_bind_config_service_actions_early(ni_ifworker_t *w, ni_fsm_t *fsm,
+		ni_dbus_xml_validate_context_t *context,
+		const ni_dbus_service_t *service)
+{
+	const ni_fsm_transition_t *action;
+	const ni_dbus_method_t *method;
+	int rv;
+
+	action = ni_fsm_transition_first();
+	for ( ; action; action = ni_fsm_transition_next(action)) {
+		if (ni_fsm_transition_is_down(action))
+			continue;
+
+		if (ni_string_empty(action->common.method_name))
+			continue;
+
+		if (!(method = ni_dbus_service_get_method(service,
+				action->common.method_name)))
+			continue;
+
+		rv = ni_ifworker_bind_config_service_method_early(
+			w, fsm, context, service, method, w->config.node
+		);
+		if (rv != NI_SUCCESS)
+			return rv;
+	}
+
+	return NI_SUCCESS;
+}
+
+int
+ni_ifworker_bind_config_services_early(ni_ifworker_t *w, ni_fsm_t *fsm,
+		ni_dbus_xml_validate_context_t *context)
+{
+	const unsigned int max = ni_objectmodel_service_registry_count();
+	const ni_dbus_service_t *services[max], *service;
+	const ni_dbus_class_t *class;
+	unsigned int count, i;
+	int rv;
+
+	/* Hmm.. modem should not differ, but...*/
+	if (w->type != NI_IFWORKER_TYPE_NETDEV)
+		return NI_SUCCESS;
+
+	if (!(class = ni_objectmodel_get_class(NI_OBJECTMODEL_NETIF_CLASS)))
+		return NI_SUCCESS;
+
+	count = ni_objectmodel_compatible_services_for_class(class, services, max);
+	for (i = 0; i < count; ++i) {
+		service = services[i];
+		rv = ni_ifworker_bind_config_service_actions_early(
+			w, fsm, context, service
+		);
+		if (rv != NI_SUCCESS)
+			return rv;
+	}
+	return NI_SUCCESS;
+}
+
 int
-ni_ifworker_bind_early(ni_ifworker_t *w, ni_fsm_t *fsm, ni_bool_t prompt_now)
+ni_ifworker_bind_config_early(ni_ifworker_t *w, ni_fsm_t *fsm, ni_bool_t prompt_now)
 {
 	struct ni_ifworker_xml_validation_user_data user_data = {
 		.fsm = fsm, .worker = w,
@@ -3632,6 +4154,9 @@ ni_ifworker_bind_early(ni_ifworker_t *w, ni_fsm_t *fsm, ni_bool_t prompt_now)
 	};
 	int rv = 0;
 
+	if (xml_node_is_empty(w->config.node))
+		return NI_SUCCESS;
+
 	if (prompt_now)
 		context.prompt_callback = ni_ifworker_prompt_cb;
 
